import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OrderExport, OrderExportParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询统计报表导出
 */
export async function pageOrderExport(params: OrderExportParam) {
  const res = await request.get<ApiResult<PageResult<OrderExport>>>(
    MODULES_API_URL + '/booking/order-export/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询统计报表导出列表
 */
export async function listOrderExport(params?: OrderExportParam) {
  const res = await request.get<ApiResult<OrderExport[]>>(
    MODULES_API_URL + '/booking/order-export',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加统计报表导出
 */
export async function addOrderExport(data: OrderExport) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/order-export',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改统计报表导出
 */
export async function updateOrderExport(data: OrderExport) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/order-export',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除统计报表导出
 */
export async function removeOrderExport(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/order-export/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除统计报表导出
 */
export async function removeBatchOrderExport(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/order-export/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询统计报表导出
 */
export async function getOrderExport(id: number) {
  const res = await request.get<ApiResult<OrderExport>>(
    MODULES_API_URL + '/booking/order-export/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
